const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const travel_bookings = sequelize.define(
    'travel_bookings',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      type: {
        type: DataTypes.ENUM,

        values: ['Flight', 'Hotel', 'CarRental'],
      },

      provider: {
        type: DataTypes.TEXT,
      },

      start: {
        type: DataTypes.DATE,
      },

      end: {
        type: DataTypes.DATE,
      },

      cost: {
        type: DataTypes.DECIMAL,
      },

      policy_result: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  travel_bookings.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.travel_bookings.belongsTo(db.employees, {
      as: 'employee',
      foreignKey: {
        name: 'employeeId',
      },
      constraints: false,
    });

    db.travel_bookings.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.travel_bookings.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.travel_bookings.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return travel_bookings;
};
